function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

var _Symbol$iterator;

_Symbol$iterator = Symbol.iterator;
var List = /*#__PURE__*/function (_Symbol$iterator2) {
  /**
   * Creates an array instance from array literal
   */
  function List() {
    var _this = this;

    var init = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

    _classCallCheck(this, List);

    this.init = init;

    _defineProperty(this, "value", void 0);

    _defineProperty(this, "clone", function () {
      return new List(_toConsumableArray(_this.value));
    });

    _defineProperty(this, "has", function (value) {
      return _this.value.indexOf(value) !== -1;
    });

    _defineProperty(this, "reset", function () {
      _this.value = _this.init;
      return _this;
    });

    _defineProperty(this, "at", function (index) {
      return _this.value[index];
    });

    _defineProperty(this, "set", function (value) {
      _this.value = _toConsumableArray(value);
      return _this;
    });

    _defineProperty(this, "add", function () {
      var _this$value;

      (_this$value = _this.value).push.apply(_this$value, arguments);

      return _this;
    });

    _defineProperty(this, "removeAt", function (index) {
      if (index > -1) {
        _this.value.splice(index, 1);
      }

      return _this;
    });

    _defineProperty(this, "remove", function (item) {
      var index = _this.value.indexOf(item);

      return _this.removeAt(index);
    });

    _defineProperty(this, "each", function (fn) {
      for (var i = 0, len = _this.size; i < len; ++i) {
        var _value = _this.value[i];
        fn(_value, i, _this.value);
      }
    });

    _defineProperty(this, "find", function (fn) {
      for (var i = 0, len = _this.size; i < len; ++i) {
        if (fn(_this.value[i], i, _this.value)) {
          return _this.value[i];
        }
      }
    });

    _defineProperty(this, "filter", function (fn) {
      var arr = [];

      _this.each(function () {
        if (fn.apply(void 0, arguments)) arr.push(arguments.length <= 0 ? undefined : arguments[0]);
      });

      return new List(arr);
    });

    _defineProperty(this, "clear", function () {
      while (_this.size > 0) {
        _this.value.pop();
      }

      return _this;
    });

    _defineProperty(this, "insert", function (index) {
      var _this$value2;

      for (var _len = arguments.length, items = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        items[_key - 1] = arguments[_key];
      }

      (_this$value2 = _this.value).splice.apply(_this$value2, [index, 0].concat(items));

      return _this;
    });

    _defineProperty(this, "replace", function (index) {
      var _this$value3;

      for (var _len2 = arguments.length, items = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        items[_key2 - 1] = arguments[_key2];
      }

      (_this$value3 = _this.value).splice.apply(_this$value3, [index, 1].concat(items));

      return _this;
    });

    _defineProperty(this, "move", function (from, to) {
      var fromIndex = from < 0 ? _this.size + from : from;

      if (fromIndex >= 0 && fromIndex < _this.size) {
        var toIndex = to < 0 ? _this.size + to : to;

        var _this$value$splice = _this.value.splice(from, 1),
            _this$value$splice2 = _slicedToArray(_this$value$splice, 1),
            _item = _this$value$splice2[0];

        _this.value.splice(toIndex, 0, _item);
      }

      return _this;
    });

    _defineProperty(this, "indexOf", function (item) {
      return _this.value.indexOf(item);
    });

    _defineProperty(this, "nextIndex", function (index) {
      var step = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
      var loop = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var nextIndex = index + step;
      var length = _this.value.length;
      var lastIndex = length - 1;

      if (index === -1) {
        return step > 0 ? 0 : lastIndex;
      }

      if (nextIndex < 0) {
        return loop ? lastIndex : 0;
      }

      if (nextIndex >= length) {
        return loop ? 0 : index > length ? length : index;
      }

      return nextIndex;
    });

    _defineProperty(this, "next", function (index) {
      var step = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
      var loop = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      var nextIndex = _this.nextIndex(index, step, loop);

      return _this.value[nextIndex];
    });

    _defineProperty(this, "prevIndex", function (index) {
      var step = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
      var loop = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      return _this.nextIndex(index, -step, loop);
    });

    _defineProperty(this, "prev", function (index) {
      var step = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
      var loop = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

      var prevIndex = _this.prevIndex(index, step, loop);

      return _this.value[prevIndex];
    });

    _defineProperty(this, "search", function (query, toString, current) {
      if (query === null || query === undefined) {
        return current;
      } // If current item doesn't exist, find the item that matches the search string


      if (!current) {
        return _this.find(function (item) {
          var itemString = toString(item);
          return itemString.toLowerCase().startsWith(query.toLowerCase());
        });
      } // Filter items for ones that match the search string (case insensitive)


      var filtered = _this.filter(function (item) {
        var itemString = toString(item);
        return itemString.toLowerCase().startsWith(query.toLowerCase());
      }); // If there are no matches, return the current item


      if (filtered.isEmpty) return current; // If there is only one match, return it

      if (filtered.size === 1) return filtered.first; // If there are multiple matches, return the next one after the current item

      return filtered.next(_this.indexOf(current));
    });

    _defineProperty(this, "chunk", function (size) {
      var result = new List([]);
      return _this.value.reduce(function (rows, value, index) {
        if (index % size === 0) {
          var _arr = new List([value]);

          rows.add(_arr);
        } else {
          var _rows$last;

          (_rows$last = rows.last) === null || _rows$last === void 0 ? void 0 : _rows$last.add(value);
        }

        return rows;
      }, result);
    });

    this.value = _toConsumableArray(init);
  }
  /**
   * Creates a copy of the array
   */


  _createClass(List, [{
    key: "size",
    get:
    /* -----------------------------------------------------------------------------
     * Array properties
     * -----------------------------------------------------------------------------*/

    /**
     * The length of the array
     */
    function get() {
      return this.value.length;
    }
    /**
     * The first item in the array
     */

  }, {
    key: "first",
    get: function get() {
      return this.value[0];
    }
    /**
     *  The last item in the array
     */

  }, {
    key: "last",
    get: function get() {
      return this.value[this.size - 1];
    }
    /**
     * Returns whether the array is empty
     */

  }, {
    key: "isEmpty",
    get: function get() {
      return this.size === 0;
    }
    /* -----------------------------------------------------------------------------
     * Query Methods
     * -----------------------------------------------------------------------------*/

    /**
     * Returns whether the array contains a value
     */

  }, {
    key: _Symbol$iterator2,
    value:
    /*#__PURE__*/

    /**
     * Iterator for the underlying array
     */
    regeneratorRuntime.mark(function value() {
      var i, len;
      return regeneratorRuntime.wrap(function value$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              i = 0, len = this.size;

            case 1:
              if (!(i < len)) {
                _context.next = 7;
                break;
              }

              _context.next = 4;
              return this.value[i];

            case 4:
              ++i;
              _context.next = 1;
              break;

            case 7:
            case "end":
              return _context.stop();
          }
        }
      }, value, this);
    })
  }], [{
    key: "from",
    value:
    /**
     * The array value
     */

    /* -----------------------------------------------------------------------------
     * Creating the array
     * -----------------------------------------------------------------------------*/

    /**
     * Cast a value to an array
     */
    function from(value) {
      var result = List.cast(value);
      return new List(result);
    }
    /**
     * Creates the array from specified length
     */

  }, {
    key: "fromLength",
    value: function fromLength(length, cb) {
      var result = _toConsumableArray(Array(length).keys()).map(cb);

      return new List(result);
    }
  }]);

  return List;
}(_Symbol$iterator);

_defineProperty(List, "cast", function (value) {
  if (!value) return [];
  return Array.isArray(value) ? value : [value];
});

export { List };
